type token =
  | IDENTIFIER of (string)
  | CONSTANT of (Jc_ast.const)
  | STRING_LITERAL of (string)
  | LPAR
  | RPAR
  | LPARRPAR
  | LBRACE
  | RBRACE
  | LSQUARE
  | RSQUARE
  | DOTDOT
  | SEMICOLON
  | COMMA
  | COLON
  | DOT
  | QUESTION
  | MINUS
  | MINUSMINUS
  | PLUS
  | PLUSPLUS
  | STAR
  | SLASH
  | PERCENT
  | EQ
  | LTEQ
  | GTEQ
  | GT
  | LT
  | EQEQ
  | BANGEQ
  | LTCOLON
  | COLONGT
  | PLUSEQ
  | MINUSEQ
  | STAREQ
  | SLASHEQ
  | PERCENTEQ
  | AMPAMP
  | BARBAR
  | EQGT
  | LTEQGT
  | EXCLAM
  | IF
  | ELSE
  | RETURN
  | WHILE
  | BREAK
  | EXCEPTION
  | OF
  | THROW
  | TRY
  | CATCH
  | PACK
  | UNPACK
  | TYPE
  | INVARIANT
  | LOGIC
  | WITH
  | VARIANT
  | INTEGER
  | BOOLEAN
  | REAL
  | UNIT
  | ASSIGNS
  | ASSUMES
  | BEHAVIOR
  | ENSURES
  | REQUIRES
  | THROWS
  | BSFORALL
  | BSOFFSET_MAX
  | BSOFFSET_MIN
  | BSOLD
  | BSRESULT
  | BSNOTHING
  | AXIOM
  | EOF

open Parsing;;
# 28 "jc/jc_parser.mly"

  open Format
  open Jc_env
  open Jc_ast
  open Jc_pervasives
  open Parsing
  open Error

  let loc () = (symbol_start_pos (), symbol_end_pos ())
  let loc_i i = (rhs_start_pos i, rhs_end_pos i)

  let locate_type e =
    { jc_ptype_node = e ; jc_ptype_loc = loc () }

  let locate_expr e =
    { jc_pexpr_node = e ; jc_pexpr_loc = loc () }

  let locate_statement s =
    { jc_pstatement_node = s ; jc_pstatement_loc = loc () }

  let locate_decl d =
    { jc_pdecl_node = d ; jc_pdecl_loc = loc () }


(*
  let locate x = { node = x; loc = loc() }
  let locate_i i x = { node = x; loc = loc_i i }
  let with_loc l x = { node = x; loc = l }
*)

  let skip = locate_statement JCPSskip
      

# 116 "jc/jc_parser.ml"
let yytransl_const = [|
  260 (* LPAR *);
  261 (* RPAR *);
  262 (* LPARRPAR *);
  263 (* LBRACE *);
  264 (* RBRACE *);
  265 (* LSQUARE *);
  266 (* RSQUARE *);
  267 (* DOTDOT *);
  268 (* SEMICOLON *);
  269 (* COMMA *);
  270 (* COLON *);
  271 (* DOT *);
  272 (* QUESTION *);
  273 (* MINUS *);
  274 (* MINUSMINUS *);
  275 (* PLUS *);
  276 (* PLUSPLUS *);
  277 (* STAR *);
  278 (* SLASH *);
  279 (* PERCENT *);
  280 (* EQ *);
  281 (* LTEQ *);
  282 (* GTEQ *);
  283 (* GT *);
  284 (* LT *);
  285 (* EQEQ *);
  286 (* BANGEQ *);
  287 (* LTCOLON *);
  288 (* COLONGT *);
  289 (* PLUSEQ *);
  290 (* MINUSEQ *);
  291 (* STAREQ *);
  292 (* SLASHEQ *);
  293 (* PERCENTEQ *);
  294 (* AMPAMP *);
  295 (* BARBAR *);
  296 (* EQGT *);
  297 (* LTEQGT *);
  298 (* EXCLAM *);
  299 (* IF *);
  300 (* ELSE *);
  301 (* RETURN *);
  302 (* WHILE *);
  303 (* BREAK *);
  304 (* EXCEPTION *);
  305 (* OF *);
  306 (* THROW *);
  307 (* TRY *);
  308 (* CATCH *);
  309 (* PACK *);
  310 (* UNPACK *);
  311 (* TYPE *);
  312 (* INVARIANT *);
  313 (* LOGIC *);
  314 (* WITH *);
  315 (* VARIANT *);
  316 (* INTEGER *);
  317 (* BOOLEAN *);
  318 (* REAL *);
  319 (* UNIT *);
  320 (* ASSIGNS *);
  321 (* ASSUMES *);
  322 (* BEHAVIOR *);
  323 (* ENSURES *);
  324 (* REQUIRES *);
  325 (* THROWS *);
  326 (* BSFORALL *);
  327 (* BSOFFSET_MAX *);
  328 (* BSOFFSET_MIN *);
  329 (* BSOLD *);
  330 (* BSRESULT *);
  331 (* BSNOTHING *);
  332 (* AXIOM *);
    0 (* EOF *);
    0|]

let yytransl_block = [|
  257 (* IDENTIFIER *);
  258 (* CONSTANT *);
  259 (* STRING_LITERAL *);
    0|]

let yylhs = "\255\255\
\001\000\001\000\002\000\002\000\002\000\002\000\004\000\004\000\
\004\000\007\000\007\000\008\000\008\000\009\000\009\000\009\000\
\010\000\011\000\014\000\014\000\014\000\015\000\015\000\016\000\
\012\000\012\000\012\000\012\000\012\000\012\000\012\000\012\000\
\012\000\012\000\017\000\017\000\018\000\018\000\019\000\019\000\
\020\000\020\000\021\000\021\000\021\000\003\000\005\000\006\000\
\025\000\025\000\025\000\025\000\025\000\026\000\026\000\026\000\
\026\000\026\000\026\000\026\000\026\000\026\000\026\000\026\000\
\026\000\026\000\026\000\023\000\023\000\028\000\028\000\028\000\
\028\000\029\000\029\000\029\000\030\000\031\000\031\000\031\000\
\031\000\031\000\031\000\031\000\032\000\032\000\032\000\033\000\
\034\000\035\000\036\000\036\000\037\000\037\000\038\000\038\000\
\027\000\027\000\039\000\039\000\039\000\039\000\039\000\039\000\
\013\000\013\000\013\000\013\000\040\000\040\000\022\000\041\000\
\041\000\024\000\042\000\042\000\044\000\044\000\045\000\045\000\
\046\000\047\000\048\000\048\000\049\000\049\000\043\000\043\000\
\043\000\043\000\043\000\043\000\043\000\043\000\050\000\050\000\
\000\000"

let yylen = "\002\000\
\002\000\001\000\001\000\001\000\001\000\001\000\006\000\007\000\
\003\000\001\000\002\000\000\000\002\000\000\000\002\000\002\000\
\003\000\008\000\001\000\002\000\003\000\001\000\003\000\002\000\
\001\000\001\000\001\000\001\000\001\000\004\000\004\000\005\000\
\006\000\005\000\000\000\002\000\003\000\009\000\000\000\003\000\
\000\000\003\000\000\000\003\000\003\000\005\000\004\000\004\000\
\001\000\001\000\001\000\001\000\003\000\001\000\003\000\004\000\
\004\000\004\000\004\000\003\000\002\000\002\000\002\000\002\000\
\002\000\002\000\002\000\001\000\003\000\001\000\003\000\003\000\
\003\000\001\000\003\000\003\000\001\000\001\000\003\000\003\000\
\003\000\003\000\003\000\003\000\001\000\003\000\003\000\001\000\
\001\000\001\000\001\000\003\000\001\000\003\000\001\000\005\000\
\001\000\003\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\005\000\003\000\003\000\001\000\003\000\001\000\003\000\
\005\000\003\000\000\000\002\000\001\000\002\000\005\000\007\000\
\004\000\006\000\002\000\003\000\005\000\005\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\004\000\006\000\
\002\000"

let yydefred = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\025\000\026\000\
\027\000\028\000\000\000\002\000\137\000\000\000\003\000\004\000\
\005\000\006\000\000\000\000\000\000\000\000\000\000\000\000\000\
\001\000\000\000\000\000\000\000\000\000\000\000\009\000\000\000\
\000\000\019\000\000\000\031\000\000\000\000\000\030\000\048\000\
\000\000\010\000\000\000\000\000\000\000\049\000\051\000\000\000\
\052\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\050\000\000\000\000\000\000\000\105\000\000\000\
\000\000\078\000\000\000\000\000\089\000\090\000\091\000\000\000\
\000\000\097\000\020\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\032\000\034\000\013\000\011\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\062\000\
\061\000\099\000\100\000\101\000\102\000\103\000\104\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\024\000\021\000\000\000\000\000\000\000\000\000\046\000\036\000\
\033\000\007\000\000\000\000\000\000\000\000\000\000\000\053\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\055\000\
\000\000\000\000\060\000\098\000\000\000\000\000\000\000\000\000\
\000\000\000\000\081\000\082\000\080\000\079\000\083\000\084\000\
\000\000\000\000\092\000\000\000\000\000\023\000\000\000\037\000\
\000\000\117\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\127\000\132\000\000\000\000\000\
\128\000\129\000\130\000\131\000\133\000\134\000\000\000\008\000\
\015\000\016\000\000\000\000\000\000\000\058\000\059\000\057\000\
\056\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\123\000\111\000\000\000\000\000\000\000\000\000\000\000\118\000\
\114\000\116\000\000\000\017\000\110\000\000\000\069\000\096\000\
\000\000\000\000\000\000\000\000\124\000\000\000\000\000\000\000\
\000\000\000\000\000\000\112\000\000\000\000\000\040\000\000\000\
\000\000\000\000\000\000\000\000\121\000\135\000\000\000\000\000\
\000\000\000\000\000\000\042\000\000\000\000\000\000\000\000\000\
\000\000\000\000\125\000\126\000\113\000\000\000\045\000\044\000\
\000\000\000\000\000\000\136\000\000\000\038\000\120\000\000\000\
\018\000\122\000"

let yydgoto = "\002\000\
\013\000\014\000\015\000\016\000\017\000\018\000\044\000\045\000\
\140\000\141\000\142\000\187\000\188\000\035\000\077\000\078\000\
\081\000\082\000\213\000\235\000\250\000\219\000\153\000\189\000\
\061\000\062\000\063\000\064\000\065\000\066\000\067\000\068\000\
\069\000\070\000\071\000\072\000\073\000\074\000\112\000\146\000\
\190\000\191\000\192\000\193\000\194\000\195\000\239\000\196\000\
\197\000\198\000"

let yysindex = "\013\000\
\250\004\000\000\020\255\094\255\109\255\080\255\000\000\000\000\
\000\000\000\000\141\255\000\000\000\000\250\004\000\000\000\000\
\000\000\000\000\144\255\135\255\090\255\129\255\180\255\155\255\
\000\000\168\255\036\255\022\255\042\255\039\255\000\000\168\005\
\255\254\000\000\215\254\000\000\086\255\176\255\000\000\000\000\
\132\255\000\000\195\255\205\255\199\255\000\000\000\000\168\005\
\000\000\188\005\188\005\188\005\188\005\188\005\042\255\221\255\
\232\255\246\255\000\000\049\255\252\255\062\003\000\000\216\255\
\190\255\000\000\186\255\200\255\000\000\000\000\000\000\219\255\
\005\255\000\000\000\000\006\000\003\000\253\255\008\000\168\005\
\004\000\215\254\033\000\000\000\000\000\000\000\000\000\021\255\
\038\255\012\255\029\000\029\000\029\000\029\000\029\000\011\000\
\168\005\168\005\168\005\168\005\168\005\160\003\044\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\188\005\
\188\005\188\005\188\005\188\005\188\005\188\005\188\005\188\005\
\188\005\045\000\046\000\188\005\188\005\188\005\168\005\188\005\
\000\000\000\000\042\255\034\000\252\254\181\255\000\000\000\000\
\000\000\000\000\049\000\043\000\038\255\038\255\051\000\000\000\
\040\000\042\000\014\255\023\255\077\255\015\000\049\255\000\000\
\054\000\047\000\000\000\000\000\153\255\153\255\153\255\153\255\
\216\255\216\255\000\000\000\000\000\000\000\000\000\000\000\000\
\186\255\186\255\000\000\249\254\219\255\000\000\255\255\000\000\
\020\255\000\000\061\000\168\005\168\005\057\000\065\000\181\255\
\068\000\069\000\073\000\008\255\000\000\000\000\067\000\181\255\
\000\000\000\000\000\000\000\000\000\000\000\000\072\000\000\000\
\000\000\000\000\074\000\011\000\168\005\000\000\000\000\000\000\
\000\000\188\005\188\005\065\000\016\000\168\005\074\255\154\255\
\000\000\000\000\168\005\032\000\168\005\168\005\018\255\000\000\
\000\000\000\000\107\000\000\000\000\000\049\255\000\000\000\000\
\097\000\168\005\048\000\087\255\000\000\168\005\181\255\100\255\
\065\000\114\255\116\255\000\000\168\005\106\000\000\000\108\255\
\105\255\050\000\181\255\118\255\000\000\000\000\109\000\103\000\
\104\000\120\255\089\000\000\000\108\000\112\000\168\005\075\000\
\059\000\181\255\000\000\000\000\000\000\168\005\000\000\000\000\
\122\255\181\255\168\005\000\000\124\255\000\000\000\000\126\255\
\000\000\000\000"

let yyrindex = "\000\000\
\000\000\000\000\024\005\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\118\000\000\000\000\000\
\000\000\000\000\123\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\042\005\001\000\135\001\000\000\139\002\
\078\003\000\000\143\003\047\004\000\000\000\000\000\000\100\004\
\167\004\000\000\000\000\000\000\000\000\126\000\000\000\000\000\
\000\000\123\000\000\000\000\000\000\000\000\000\000\000\000\000\
\125\000\000\000\066\000\131\000\196\000\005\001\070\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\129\000\000\000\000\000\
\000\000\000\000\000\000\000\000\125\000\125\000\000\000\000\000\
\122\000\000\000\000\000\000\000\000\000\197\004\230\004\000\000\
\000\000\053\255\000\000\000\000\200\001\009\002\074\002\135\001\
\204\002\013\003\000\000\000\000\000\000\000\000\000\000\000\000\
\208\003\017\004\000\000\000\000\130\004\000\000\138\255\000\000\
\251\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\062\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\004\005\000\000\000\000\
\000\000\000\000\071\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\105\005\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000"

let yygindex = "\000\000\
\125\001\000\000\000\000\000\000\000\000\000\000\052\001\000\000\
\105\000\000\000\000\000\002\000\226\255\000\000\010\001\000\000\
\064\001\000\000\000\000\000\000\000\000\066\255\052\255\068\001\
\000\000\215\255\159\255\132\000\000\000\101\000\135\000\000\000\
\000\000\000\000\025\001\045\001\000\000\219\000\000\000\227\000\
\000\000\240\000\098\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000"

let yytablesize = 1828
let yytable = "\003\000\
\054\000\060\000\019\000\075\000\154\000\231\000\211\000\176\000\
\091\000\092\000\093\000\094\000\095\000\001\000\156\000\019\000\
\144\000\090\000\206\000\224\000\127\000\233\000\042\000\038\000\
\079\000\220\000\080\000\207\000\020\000\244\000\040\000\039\000\
\100\000\101\000\076\000\100\000\101\000\043\000\003\000\041\000\
\042\000\245\000\003\000\128\000\006\001\036\000\037\000\100\000\
\101\000\133\000\255\000\100\000\101\000\100\000\101\000\043\000\
\096\000\068\000\007\000\008\000\009\000\010\000\100\000\101\000\
\068\000\066\000\147\000\148\000\149\000\150\000\151\000\157\000\
\158\000\159\000\160\000\160\000\160\000\160\000\160\000\160\000\
\253\000\208\000\160\000\160\000\160\000\237\000\160\000\083\000\
\100\000\101\000\143\000\251\000\008\001\139\000\021\000\084\000\
\172\000\007\000\008\000\009\000\010\000\007\000\008\000\009\000\
\010\000\046\000\047\000\020\001\048\000\022\000\049\000\254\000\
\154\000\100\000\101\000\023\001\100\000\101\000\000\001\004\001\
\001\001\050\000\051\000\052\000\053\000\041\000\100\000\101\000\
\041\000\009\001\064\000\013\001\076\000\022\001\023\000\025\001\
\027\000\026\001\029\000\100\000\101\000\024\000\143\000\143\000\
\026\000\028\000\054\000\100\000\101\000\215\000\216\000\154\000\
\030\000\100\000\101\000\100\000\101\000\100\000\101\000\100\000\
\101\000\100\000\101\000\100\000\101\000\100\000\101\000\103\000\
\032\000\160\000\104\000\033\000\105\000\034\000\230\000\056\000\
\057\000\058\000\059\000\005\001\031\000\177\000\047\000\236\000\
\048\000\085\000\049\000\134\000\240\000\086\000\242\000\243\000\
\178\000\100\000\101\000\065\000\087\000\050\000\051\000\052\000\
\053\000\039\000\039\000\248\000\039\000\089\000\116\000\252\000\
\117\000\238\000\118\000\119\000\120\000\121\000\002\001\088\000\
\122\000\123\000\163\000\164\000\165\000\166\000\054\000\179\000\
\097\000\180\000\181\000\182\000\124\000\125\000\183\000\184\000\
\017\001\185\000\186\000\098\000\113\000\114\000\115\000\021\001\
\007\000\008\000\009\000\010\000\024\001\201\000\202\000\161\000\
\162\000\099\000\055\000\056\000\057\000\058\000\059\000\102\000\
\126\000\054\000\169\000\170\000\063\000\054\000\129\000\130\000\
\132\000\131\000\134\000\145\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\137\000\103\000\155\000\167\000\168\000\175\000\
\054\000\199\000\200\000\203\000\204\000\205\000\100\000\054\000\
\054\000\054\000\209\000\210\000\054\000\054\000\054\000\054\000\
\214\000\218\000\066\000\212\000\217\000\067\000\066\000\221\000\
\222\000\223\000\225\000\227\000\054\000\066\000\066\000\066\000\
\234\000\066\000\066\000\241\000\066\000\228\000\066\000\066\000\
\066\000\066\000\066\000\066\000\066\000\066\000\066\000\066\000\
\066\000\066\000\066\000\066\000\066\000\066\000\066\000\066\000\
\066\000\066\000\066\000\246\000\247\000\010\001\003\001\249\000\
\014\001\066\000\011\001\012\001\007\001\019\001\018\001\015\001\
\066\000\066\000\066\000\016\001\012\000\066\000\066\000\066\000\
\066\000\035\000\022\000\064\000\014\000\109\000\070\000\064\000\
\115\000\043\000\025\000\138\000\174\000\066\000\064\000\064\000\
\064\000\136\000\064\000\064\000\135\000\064\000\171\000\064\000\
\064\000\064\000\064\000\064\000\064\000\064\000\064\000\064\000\
\064\000\064\000\064\000\064\000\064\000\064\000\064\000\064\000\
\064\000\064\000\064\000\064\000\173\000\232\000\229\000\226\000\
\000\000\000\000\064\000\000\000\000\000\000\000\000\000\000\000\
\000\000\064\000\064\000\064\000\000\000\000\000\064\000\064\000\
\064\000\064\000\000\000\000\000\065\000\000\000\000\000\071\000\
\065\000\000\000\000\000\000\000\000\000\000\000\064\000\065\000\
\065\000\065\000\000\000\065\000\065\000\000\000\065\000\000\000\
\065\000\065\000\065\000\065\000\065\000\065\000\065\000\065\000\
\065\000\065\000\065\000\065\000\065\000\065\000\065\000\065\000\
\065\000\065\000\065\000\065\000\065\000\000\000\000\000\000\000\
\000\000\000\000\000\000\065\000\000\000\000\000\000\000\000\000\
\000\000\000\000\065\000\065\000\065\000\000\000\000\000\065\000\
\065\000\065\000\065\000\000\000\000\000\063\000\000\000\000\000\
\072\000\063\000\000\000\000\000\000\000\000\000\000\000\065\000\
\063\000\063\000\063\000\000\000\063\000\063\000\000\000\063\000\
\000\000\063\000\063\000\063\000\063\000\063\000\063\000\063\000\
\063\000\063\000\063\000\063\000\063\000\063\000\063\000\063\000\
\063\000\063\000\063\000\063\000\063\000\063\000\000\000\000\000\
\000\000\000\000\000\000\000\000\063\000\000\000\000\000\000\000\
\000\000\000\000\000\000\063\000\063\000\063\000\000\000\000\000\
\063\000\063\000\063\000\063\000\000\000\000\000\067\000\000\000\
\000\000\073\000\067\000\000\000\000\000\000\000\000\000\000\000\
\063\000\067\000\067\000\067\000\000\000\067\000\067\000\000\000\
\067\000\000\000\067\000\067\000\067\000\067\000\067\000\067\000\
\067\000\067\000\067\000\067\000\067\000\067\000\067\000\067\000\
\067\000\067\000\067\000\067\000\067\000\067\000\067\000\000\000\
\000\000\000\000\000\000\000\000\000\000\067\000\000\000\000\000\
\000\000\000\000\000\000\000\000\067\000\067\000\067\000\000\000\
\000\000\067\000\067\000\067\000\067\000\000\000\000\000\070\000\
\000\000\000\000\074\000\070\000\000\000\000\000\000\000\000\000\
\000\000\067\000\070\000\070\000\070\000\000\000\070\000\070\000\
\000\000\070\000\000\000\070\000\070\000\070\000\000\000\070\000\
\070\000\070\000\070\000\070\000\070\000\070\000\070\000\000\000\
\000\000\000\000\000\000\000\000\070\000\070\000\070\000\070\000\
\000\000\000\000\000\000\000\000\000\000\000\000\070\000\000\000\
\000\000\000\000\000\000\000\000\000\000\070\000\070\000\070\000\
\000\000\000\000\070\000\070\000\070\000\070\000\000\000\000\000\
\071\000\000\000\000\000\076\000\071\000\000\000\000\000\000\000\
\000\000\000\000\070\000\071\000\071\000\071\000\000\000\071\000\
\071\000\000\000\071\000\000\000\071\000\071\000\071\000\000\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\000\000\000\000\000\000\000\000\000\000\071\000\071\000\071\000\
\071\000\000\000\000\000\000\000\000\000\000\000\000\000\071\000\
\000\000\000\000\000\000\000\000\000\000\000\000\071\000\071\000\
\071\000\000\000\000\000\071\000\071\000\071\000\071\000\000\000\
\000\000\072\000\000\000\000\000\075\000\072\000\000\000\000\000\
\000\000\000\000\000\000\071\000\072\000\072\000\072\000\000\000\
\072\000\072\000\000\000\072\000\000\000\072\000\072\000\072\000\
\000\000\072\000\072\000\072\000\072\000\072\000\072\000\072\000\
\072\000\000\000\000\000\000\000\000\000\000\000\072\000\072\000\
\072\000\072\000\000\000\000\000\000\000\000\000\000\000\000\000\
\072\000\000\000\000\000\000\000\000\000\000\000\000\000\072\000\
\072\000\072\000\000\000\000\000\072\000\072\000\072\000\072\000\
\000\000\000\000\073\000\000\000\000\000\077\000\073\000\000\000\
\000\000\000\000\000\000\000\000\072\000\073\000\073\000\073\000\
\000\000\073\000\073\000\000\000\073\000\000\000\073\000\073\000\
\073\000\000\000\073\000\073\000\073\000\073\000\073\000\073\000\
\073\000\073\000\000\000\000\000\000\000\000\000\000\000\073\000\
\073\000\073\000\073\000\000\000\000\000\000\000\000\000\000\000\
\000\000\073\000\000\000\000\000\000\000\000\000\000\000\000\000\
\073\000\073\000\073\000\000\000\000\000\073\000\073\000\073\000\
\073\000\000\000\000\000\074\000\000\000\000\000\085\000\074\000\
\000\000\000\000\000\000\000\000\000\000\073\000\074\000\074\000\
\074\000\000\000\074\000\074\000\000\000\074\000\000\000\000\000\
\000\000\000\000\000\000\074\000\074\000\074\000\074\000\074\000\
\074\000\074\000\074\000\000\000\000\000\000\000\000\000\000\000\
\074\000\074\000\074\000\074\000\000\000\000\000\000\000\000\000\
\000\000\000\000\074\000\000\000\000\000\000\000\000\000\000\000\
\000\000\074\000\074\000\074\000\000\000\000\000\074\000\074\000\
\074\000\074\000\000\000\000\000\076\000\000\000\000\000\086\000\
\076\000\000\000\000\000\000\000\000\000\000\000\074\000\076\000\
\076\000\076\000\000\000\076\000\076\000\000\000\076\000\000\000\
\000\000\000\000\000\000\000\000\076\000\076\000\076\000\076\000\
\076\000\076\000\076\000\076\000\000\000\000\000\000\000\000\000\
\000\000\076\000\076\000\076\000\076\000\000\000\000\000\000\000\
\000\000\000\000\000\000\076\000\000\000\000\000\000\000\000\000\
\000\000\000\000\076\000\076\000\076\000\000\000\000\000\076\000\
\076\000\076\000\076\000\000\000\000\000\075\000\000\000\000\000\
\087\000\075\000\000\000\000\000\000\000\000\000\000\000\076\000\
\075\000\075\000\075\000\000\000\075\000\075\000\000\000\075\000\
\000\000\000\000\000\000\000\000\000\000\075\000\075\000\075\000\
\075\000\075\000\075\000\075\000\075\000\000\000\088\000\000\000\
\000\000\000\000\075\000\075\000\075\000\075\000\000\000\000\000\
\000\000\000\000\000\000\000\000\075\000\000\000\000\000\000\000\
\000\000\000\000\000\000\075\000\075\000\075\000\000\000\000\000\
\075\000\075\000\075\000\075\000\103\000\000\000\077\000\104\000\
\000\000\105\000\077\000\000\000\000\000\106\000\000\000\000\000\
\075\000\077\000\077\000\077\000\000\000\077\000\107\000\108\000\
\109\000\110\000\111\000\093\000\000\000\000\000\077\000\077\000\
\077\000\077\000\077\000\077\000\077\000\077\000\000\000\000\000\
\000\000\000\000\000\000\077\000\077\000\077\000\077\000\000\000\
\000\000\000\000\000\000\000\000\000\000\077\000\000\000\000\000\
\000\000\094\000\000\000\000\000\077\000\077\000\077\000\000\000\
\000\000\077\000\077\000\077\000\077\000\000\000\000\000\085\000\
\000\000\000\000\000\000\085\000\000\000\000\000\000\000\000\000\
\000\000\077\000\085\000\085\000\085\000\000\000\085\000\000\000\
\046\000\047\000\000\000\048\000\152\000\049\000\095\000\000\000\
\000\000\000\000\000\000\085\000\085\000\000\000\000\000\000\000\
\050\000\051\000\052\000\053\000\085\000\085\000\085\000\085\000\
\000\000\000\000\000\000\000\000\000\000\000\000\085\000\000\000\
\000\000\000\000\000\000\000\000\107\000\085\000\085\000\085\000\
\000\000\054\000\085\000\085\000\085\000\085\000\000\000\000\000\
\086\000\000\000\000\000\000\000\086\000\000\000\000\000\000\000\
\000\000\000\000\085\000\086\000\086\000\086\000\000\000\086\000\
\000\000\000\000\000\000\000\000\000\000\108\000\056\000\057\000\
\058\000\059\000\000\000\000\000\086\000\086\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\086\000\086\000\086\000\
\086\000\012\000\000\000\000\000\000\000\000\000\000\000\086\000\
\000\000\000\000\000\000\106\000\000\000\000\000\086\000\086\000\
\086\000\000\000\000\000\086\000\086\000\086\000\086\000\000\000\
\000\000\087\000\000\000\000\000\000\000\087\000\000\000\029\000\
\000\000\000\000\000\000\086\000\087\000\087\000\087\000\000\000\
\087\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\047\000\000\000\000\000\000\000\087\000\087\000\088\000\
\000\000\000\000\000\000\088\000\000\000\000\000\087\000\087\000\
\087\000\087\000\088\000\088\000\088\000\000\000\088\000\000\000\
\087\000\000\000\000\000\000\000\000\000\000\000\000\000\087\000\
\087\000\087\000\000\000\000\000\087\000\087\000\087\000\087\000\
\000\000\000\000\000\000\000\000\088\000\088\000\088\000\088\000\
\000\000\000\000\000\000\000\000\087\000\000\000\088\000\000\000\
\000\000\000\000\000\000\000\000\093\000\088\000\088\000\088\000\
\093\000\000\000\088\000\088\000\088\000\088\000\000\000\093\000\
\093\000\093\000\000\000\093\000\000\000\000\000\000\000\000\000\
\000\000\000\000\088\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\094\000\000\000\000\000\000\000\094\000\000\000\
\000\000\000\000\093\000\093\000\093\000\094\000\094\000\094\000\
\000\000\094\000\000\000\093\000\000\000\000\000\000\000\000\000\
\000\000\000\000\093\000\093\000\093\000\000\000\000\000\093\000\
\093\000\093\000\093\000\000\000\000\000\000\000\000\000\095\000\
\094\000\094\000\094\000\095\000\000\000\000\000\000\000\093\000\
\000\000\094\000\095\000\095\000\095\000\000\000\000\000\000\000\
\094\000\094\000\094\000\000\000\000\000\094\000\094\000\094\000\
\094\000\000\000\000\000\000\000\000\000\107\000\000\000\000\000\
\000\000\107\000\000\000\000\000\000\000\094\000\095\000\095\000\
\107\000\000\000\107\000\000\000\000\000\000\000\095\000\000\000\
\000\000\000\000\000\000\000\000\000\000\095\000\095\000\095\000\
\000\000\000\000\095\000\095\000\095\000\095\000\108\000\000\000\
\000\000\000\000\108\000\000\000\000\000\107\000\000\000\000\000\
\000\000\108\000\095\000\108\000\107\000\000\000\000\000\000\000\
\000\000\000\000\003\000\107\000\107\000\107\000\000\000\000\000\
\107\000\107\000\107\000\107\000\106\000\000\000\000\000\000\000\
\106\000\000\000\000\000\000\000\000\000\000\000\000\000\106\000\
\107\000\106\000\000\000\000\000\000\000\108\000\000\000\000\000\
\029\000\000\000\000\000\000\000\108\000\108\000\108\000\000\000\
\000\000\108\000\108\000\108\000\108\000\000\000\000\000\000\000\
\000\000\004\000\047\000\000\000\000\000\000\000\000\000\000\000\
\005\000\108\000\006\000\106\000\000\000\007\000\008\000\009\000\
\010\000\000\000\106\000\106\000\106\000\000\000\000\000\106\000\
\106\000\106\000\106\000\000\000\000\000\011\000\000\000\029\000\
\000\000\000\000\000\000\000\000\000\000\000\000\029\000\106\000\
\029\000\000\000\000\000\029\000\029\000\029\000\029\000\000\000\
\000\000\047\000\000\000\000\000\000\000\000\000\000\000\000\000\
\047\000\000\000\047\000\029\000\000\000\047\000\047\000\047\000\
\047\000\119\000\119\000\000\000\119\000\000\000\119\000\119\000\
\119\000\000\000\000\000\000\000\119\000\047\000\000\000\000\000\
\000\000\119\000\119\000\119\000\119\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\119\000\119\000\000\000\119\000\119\000\119\000\
\000\000\000\000\119\000\119\000\119\000\119\000\119\000\000\000\
\000\000\000\000\000\000\000\000\119\000\119\000\119\000\119\000\
\046\000\047\000\000\000\048\000\000\000\049\000\119\000\119\000\
\119\000\119\000\119\000\000\000\000\000\000\000\000\000\000\000\
\050\000\051\000\052\000\053\000\046\000\047\000\000\000\048\000\
\000\000\049\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\050\000\051\000\052\000\053\000\
\000\000\054\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\054\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\055\000\056\000\057\000\
\058\000\059\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\029\000\000\000\000\000\049\000\000\000\
\000\000\000\000\056\000\057\000\058\000\059\000\049\000\000\000\
\000\000\049\000\049\000\049\000\049\000\049\000\049\000\049\000\
\049\000\049\000\049\000\049\000\049\000\049\000\049\000\049\000\
\049\000\049\000\049\000\049\000\049\000\049\000\049\000\049\000\
\049\000\049\000\049\000\049\000"

let yycheck = "\001\001\
\000\000\032\000\001\000\005\001\102\000\210\000\014\001\012\001\
\050\000\051\000\052\000\053\000\054\000\001\000\112\000\014\000\
\005\001\048\000\005\001\012\001\016\001\212\000\002\001\002\001\
\066\001\184\000\068\001\005\001\009\001\012\001\029\000\010\001\
\040\001\041\001\033\000\040\001\041\001\017\001\001\001\001\001\
\002\001\024\001\001\001\039\001\249\000\010\001\011\001\040\001\
\041\001\080\000\241\000\040\001\041\001\040\001\041\001\017\001\
\055\000\005\001\060\001\061\001\062\001\063\001\040\001\041\001\
\012\001\000\000\097\000\098\000\099\000\100\000\101\000\113\000\
\114\000\115\000\116\000\117\000\118\000\119\000\120\000\121\000\
\239\000\005\001\124\000\125\000\126\000\012\001\128\000\002\001\
\040\001\041\001\089\000\005\001\251\000\056\001\001\001\010\001\
\127\000\060\001\061\001\062\001\063\001\060\001\061\001\062\001\
\063\001\001\001\002\001\010\001\004\001\001\001\006\001\012\001\
\210\000\040\001\041\001\018\001\040\001\041\001\005\001\012\001\
\005\001\017\001\018\001\019\001\020\001\064\001\040\001\041\001\
\067\001\012\001\000\000\012\001\131\000\012\001\055\001\012\001\
\002\001\012\001\049\001\040\001\041\001\001\001\141\000\142\000\
\001\001\011\001\042\001\040\001\041\001\180\000\181\000\249\000\
\024\001\040\001\041\001\040\001\041\001\040\001\041\001\040\001\
\041\001\040\001\041\001\040\001\041\001\040\001\041\001\015\001\
\014\001\211\000\018\001\004\001\020\001\006\001\205\000\071\001\
\072\001\073\001\074\001\075\001\001\001\001\001\002\001\214\000\
\004\001\010\001\006\001\007\001\219\000\058\001\221\000\222\000\
\012\001\040\001\041\001\000\000\002\001\017\001\018\001\019\001\
\020\001\064\001\065\001\234\000\067\001\007\001\017\001\238\000\
\019\001\056\001\025\001\026\001\027\001\028\001\245\000\011\001\
\031\001\032\001\118\000\119\000\120\000\121\000\042\001\043\001\
\004\001\045\001\046\001\047\001\029\001\030\001\050\001\051\001\
\007\001\053\001\054\001\004\001\021\001\022\001\023\001\014\001\
\060\001\061\001\062\001\063\001\019\001\141\000\142\000\116\000\
\117\000\004\001\070\001\071\001\072\001\073\001\074\001\004\001\
\038\001\001\001\124\000\125\000\000\000\005\001\001\001\005\001\
\001\001\013\001\007\001\001\001\012\001\013\001\014\001\015\001\
\016\001\017\001\018\001\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\010\001\015\001\001\001\001\001\001\001\014\001\
\048\001\001\001\008\001\001\001\013\001\012\001\040\001\055\001\
\056\001\057\001\005\001\013\001\060\001\061\001\062\001\063\001\
\004\001\001\001\001\001\069\001\012\001\000\000\005\001\004\001\
\004\001\001\001\008\001\004\001\076\001\012\001\013\001\014\001\
\065\001\016\001\017\001\052\001\019\001\012\001\021\001\022\001\
\023\001\024\001\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\032\001\033\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\001\001\012\001\001\001\005\001\064\001\
\024\001\048\001\012\001\012\001\067\001\059\001\044\001\012\001\
\055\001\056\001\057\001\012\001\007\001\060\001\061\001\062\001\
\063\001\007\001\005\001\001\001\008\001\012\001\000\000\005\001\
\008\001\067\001\014\000\088\000\131\000\076\001\012\001\013\001\
\014\001\082\000\016\001\017\001\081\000\019\001\126\000\021\001\
\022\001\023\001\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\032\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\128\000\211\000\204\000\192\000\
\255\255\255\255\048\001\255\255\255\255\255\255\255\255\255\255\
\255\255\055\001\056\001\057\001\255\255\255\255\060\001\061\001\
\062\001\063\001\255\255\255\255\001\001\255\255\255\255\000\000\
\005\001\255\255\255\255\255\255\255\255\255\255\076\001\012\001\
\013\001\014\001\255\255\016\001\017\001\255\255\019\001\255\255\
\021\001\022\001\023\001\024\001\025\001\026\001\027\001\028\001\
\029\001\030\001\031\001\032\001\033\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\048\001\255\255\255\255\255\255\255\255\
\255\255\255\255\055\001\056\001\057\001\255\255\255\255\060\001\
\061\001\062\001\063\001\255\255\255\255\001\001\255\255\255\255\
\000\000\005\001\255\255\255\255\255\255\255\255\255\255\076\001\
\012\001\013\001\014\001\255\255\016\001\017\001\255\255\019\001\
\255\255\021\001\022\001\023\001\024\001\025\001\026\001\027\001\
\028\001\029\001\030\001\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\048\001\255\255\255\255\255\255\
\255\255\255\255\255\255\055\001\056\001\057\001\255\255\255\255\
\060\001\061\001\062\001\063\001\255\255\255\255\001\001\255\255\
\255\255\000\000\005\001\255\255\255\255\255\255\255\255\255\255\
\076\001\012\001\013\001\014\001\255\255\016\001\017\001\255\255\
\019\001\255\255\021\001\022\001\023\001\024\001\025\001\026\001\
\027\001\028\001\029\001\030\001\031\001\032\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\048\001\255\255\255\255\
\255\255\255\255\255\255\255\255\055\001\056\001\057\001\255\255\
\255\255\060\001\061\001\062\001\063\001\255\255\255\255\001\001\
\255\255\255\255\000\000\005\001\255\255\255\255\255\255\255\255\
\255\255\076\001\012\001\013\001\014\001\255\255\016\001\017\001\
\255\255\019\001\255\255\021\001\022\001\023\001\255\255\025\001\
\026\001\027\001\028\001\029\001\030\001\031\001\032\001\255\255\
\255\255\255\255\255\255\255\255\038\001\039\001\040\001\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\048\001\255\255\
\255\255\255\255\255\255\255\255\255\255\055\001\056\001\057\001\
\255\255\255\255\060\001\061\001\062\001\063\001\255\255\255\255\
\001\001\255\255\255\255\000\000\005\001\255\255\255\255\255\255\
\255\255\255\255\076\001\012\001\013\001\014\001\255\255\016\001\
\017\001\255\255\019\001\255\255\021\001\022\001\023\001\255\255\
\025\001\026\001\027\001\028\001\029\001\030\001\031\001\032\001\
\255\255\255\255\255\255\255\255\255\255\038\001\039\001\040\001\
\041\001\255\255\255\255\255\255\255\255\255\255\255\255\048\001\
\255\255\255\255\255\255\255\255\255\255\255\255\055\001\056\001\
\057\001\255\255\255\255\060\001\061\001\062\001\063\001\255\255\
\255\255\001\001\255\255\255\255\000\000\005\001\255\255\255\255\
\255\255\255\255\255\255\076\001\012\001\013\001\014\001\255\255\
\016\001\017\001\255\255\019\001\255\255\021\001\022\001\023\001\
\255\255\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\255\255\255\255\255\255\255\255\255\255\038\001\039\001\
\040\001\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\048\001\255\255\255\255\255\255\255\255\255\255\255\255\055\001\
\056\001\057\001\255\255\255\255\060\001\061\001\062\001\063\001\
\255\255\255\255\001\001\255\255\255\255\000\000\005\001\255\255\
\255\255\255\255\255\255\255\255\076\001\012\001\013\001\014\001\
\255\255\016\001\017\001\255\255\019\001\255\255\021\001\022\001\
\023\001\255\255\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\032\001\255\255\255\255\255\255\255\255\255\255\038\001\
\039\001\040\001\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\048\001\255\255\255\255\255\255\255\255\255\255\255\255\
\055\001\056\001\057\001\255\255\255\255\060\001\061\001\062\001\
\063\001\255\255\255\255\001\001\255\255\255\255\000\000\005\001\
\255\255\255\255\255\255\255\255\255\255\076\001\012\001\013\001\
\014\001\255\255\016\001\017\001\255\255\019\001\255\255\255\255\
\255\255\255\255\255\255\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\032\001\255\255\255\255\255\255\255\255\255\255\
\038\001\039\001\040\001\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\048\001\255\255\255\255\255\255\255\255\255\255\
\255\255\055\001\056\001\057\001\255\255\255\255\060\001\061\001\
\062\001\063\001\255\255\255\255\001\001\255\255\255\255\000\000\
\005\001\255\255\255\255\255\255\255\255\255\255\076\001\012\001\
\013\001\014\001\255\255\016\001\017\001\255\255\019\001\255\255\
\255\255\255\255\255\255\255\255\025\001\026\001\027\001\028\001\
\029\001\030\001\031\001\032\001\255\255\255\255\255\255\255\255\
\255\255\038\001\039\001\040\001\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\048\001\255\255\255\255\255\255\255\255\
\255\255\255\255\055\001\056\001\057\001\255\255\255\255\060\001\
\061\001\062\001\063\001\255\255\255\255\001\001\255\255\255\255\
\000\000\005\001\255\255\255\255\255\255\255\255\255\255\076\001\
\012\001\013\001\014\001\255\255\016\001\017\001\255\255\019\001\
\255\255\255\255\255\255\255\255\255\255\025\001\026\001\027\001\
\028\001\029\001\030\001\031\001\032\001\255\255\000\000\255\255\
\255\255\255\255\038\001\039\001\040\001\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\048\001\255\255\255\255\255\255\
\255\255\255\255\255\255\055\001\056\001\057\001\255\255\255\255\
\060\001\061\001\062\001\063\001\015\001\255\255\001\001\018\001\
\255\255\020\001\005\001\255\255\255\255\024\001\255\255\255\255\
\076\001\012\001\013\001\014\001\255\255\016\001\033\001\034\001\
\035\001\036\001\037\001\000\000\255\255\255\255\025\001\026\001\
\027\001\028\001\029\001\030\001\031\001\032\001\255\255\255\255\
\255\255\255\255\255\255\038\001\039\001\040\001\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\048\001\255\255\255\255\
\255\255\000\000\255\255\255\255\055\001\056\001\057\001\255\255\
\255\255\060\001\061\001\062\001\063\001\255\255\255\255\001\001\
\255\255\255\255\255\255\005\001\255\255\255\255\255\255\255\255\
\255\255\076\001\012\001\013\001\014\001\255\255\016\001\255\255\
\001\001\002\001\255\255\004\001\005\001\006\001\000\000\255\255\
\255\255\255\255\255\255\029\001\030\001\255\255\255\255\255\255\
\017\001\018\001\019\001\020\001\038\001\039\001\040\001\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\048\001\255\255\
\255\255\255\255\255\255\255\255\000\000\055\001\056\001\057\001\
\255\255\042\001\060\001\061\001\062\001\063\001\255\255\255\255\
\001\001\255\255\255\255\255\255\005\001\255\255\255\255\255\255\
\255\255\255\255\076\001\012\001\013\001\014\001\255\255\016\001\
\255\255\255\255\255\255\255\255\255\255\000\000\071\001\072\001\
\073\001\074\001\255\255\255\255\029\001\030\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\038\001\039\001\040\001\
\041\001\000\000\255\255\255\255\255\255\255\255\255\255\048\001\
\255\255\255\255\255\255\000\000\255\255\255\255\055\001\056\001\
\057\001\255\255\255\255\060\001\061\001\062\001\063\001\255\255\
\255\255\001\001\255\255\255\255\255\255\005\001\255\255\000\000\
\255\255\255\255\255\255\076\001\012\001\013\001\014\001\255\255\
\016\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\000\000\255\255\255\255\255\255\029\001\030\001\001\001\
\255\255\255\255\255\255\005\001\255\255\255\255\038\001\039\001\
\040\001\041\001\012\001\013\001\014\001\255\255\016\001\255\255\
\048\001\255\255\255\255\255\255\255\255\255\255\255\255\055\001\
\056\001\057\001\255\255\255\255\060\001\061\001\062\001\063\001\
\255\255\255\255\255\255\255\255\038\001\039\001\040\001\041\001\
\255\255\255\255\255\255\255\255\076\001\255\255\048\001\255\255\
\255\255\255\255\255\255\255\255\001\001\055\001\056\001\057\001\
\005\001\255\255\060\001\061\001\062\001\063\001\255\255\012\001\
\013\001\014\001\255\255\016\001\255\255\255\255\255\255\255\255\
\255\255\255\255\076\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\001\001\255\255\255\255\255\255\005\001\255\255\
\255\255\255\255\039\001\040\001\041\001\012\001\013\001\014\001\
\255\255\016\001\255\255\048\001\255\255\255\255\255\255\255\255\
\255\255\255\255\055\001\056\001\057\001\255\255\255\255\060\001\
\061\001\062\001\063\001\255\255\255\255\255\255\255\255\001\001\
\039\001\040\001\041\001\005\001\255\255\255\255\255\255\076\001\
\255\255\048\001\012\001\013\001\014\001\255\255\255\255\255\255\
\055\001\056\001\057\001\255\255\255\255\060\001\061\001\062\001\
\063\001\255\255\255\255\255\255\255\255\001\001\255\255\255\255\
\255\255\005\001\255\255\255\255\255\255\076\001\040\001\041\001\
\012\001\255\255\014\001\255\255\255\255\255\255\048\001\255\255\
\255\255\255\255\255\255\255\255\255\255\055\001\056\001\057\001\
\255\255\255\255\060\001\061\001\062\001\063\001\001\001\255\255\
\255\255\255\255\005\001\255\255\255\255\041\001\255\255\255\255\
\255\255\012\001\076\001\014\001\048\001\255\255\255\255\255\255\
\255\255\255\255\001\001\055\001\056\001\057\001\255\255\255\255\
\060\001\061\001\062\001\063\001\001\001\255\255\255\255\255\255\
\005\001\255\255\255\255\255\255\255\255\255\255\255\255\012\001\
\076\001\014\001\255\255\255\255\255\255\048\001\255\255\255\255\
\001\001\255\255\255\255\255\255\055\001\056\001\057\001\255\255\
\255\255\060\001\061\001\062\001\063\001\255\255\255\255\255\255\
\255\255\048\001\001\001\255\255\255\255\255\255\255\255\255\255\
\055\001\076\001\057\001\048\001\255\255\060\001\061\001\062\001\
\063\001\255\255\055\001\056\001\057\001\255\255\255\255\060\001\
\061\001\062\001\063\001\255\255\255\255\076\001\255\255\048\001\
\255\255\255\255\255\255\255\255\255\255\255\255\055\001\076\001\
\057\001\255\255\255\255\060\001\061\001\062\001\063\001\255\255\
\255\255\048\001\255\255\255\255\255\255\255\255\255\255\255\255\
\055\001\255\255\057\001\076\001\255\255\060\001\061\001\062\001\
\063\001\001\001\002\001\255\255\004\001\255\255\006\001\007\001\
\008\001\255\255\255\255\255\255\012\001\076\001\255\255\255\255\
\255\255\017\001\018\001\019\001\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\042\001\043\001\255\255\045\001\046\001\047\001\
\255\255\255\255\050\001\051\001\052\001\053\001\054\001\255\255\
\255\255\255\255\255\255\255\255\060\001\061\001\062\001\063\001\
\001\001\002\001\255\255\004\001\255\255\006\001\070\001\071\001\
\072\001\073\001\074\001\255\255\255\255\255\255\255\255\255\255\
\017\001\018\001\019\001\020\001\001\001\002\001\255\255\004\001\
\255\255\006\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\017\001\018\001\019\001\020\001\
\255\255\042\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\042\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\070\001\071\001\072\001\
\073\001\074\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\001\001\255\255\255\255\004\001\255\255\
\255\255\255\255\071\001\072\001\073\001\074\001\012\001\255\255\
\255\255\015\001\016\001\017\001\018\001\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\032\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001"

let yynames_const = "\
  LPAR\000\
  RPAR\000\
  LPARRPAR\000\
  LBRACE\000\
  RBRACE\000\
  LSQUARE\000\
  RSQUARE\000\
  DOTDOT\000\
  SEMICOLON\000\
  COMMA\000\
  COLON\000\
  DOT\000\
  QUESTION\000\
  MINUS\000\
  MINUSMINUS\000\
  PLUS\000\
  PLUSPLUS\000\
  STAR\000\
  SLASH\000\
  PERCENT\000\
  EQ\000\
  LTEQ\000\
  GTEQ\000\
  GT\000\
  LT\000\
  EQEQ\000\
  BANGEQ\000\
  LTCOLON\000\
  COLONGT\000\
  PLUSEQ\000\
  MINUSEQ\000\
  STAREQ\000\
  SLASHEQ\000\
  PERCENTEQ\000\
  AMPAMP\000\
  BARBAR\000\
  EQGT\000\
  LTEQGT\000\
  EXCLAM\000\
  IF\000\
  ELSE\000\
  RETURN\000\
  WHILE\000\
  BREAK\000\
  EXCEPTION\000\
  OF\000\
  THROW\000\
  TRY\000\
  CATCH\000\
  PACK\000\
  UNPACK\000\
  TYPE\000\
  INVARIANT\000\
  LOGIC\000\
  WITH\000\
  VARIANT\000\
  INTEGER\000\
  BOOLEAN\000\
  REAL\000\
  UNIT\000\
  ASSIGNS\000\
  ASSUMES\000\
  BEHAVIOR\000\
  ENSURES\000\
  REQUIRES\000\
  THROWS\000\
  BSFORALL\000\
  BSOFFSET_MAX\000\
  BSOFFSET_MIN\000\
  BSOLD\000\
  BSRESULT\000\
  BSNOTHING\000\
  AXIOM\000\
  EOF\000\
  "

let yynames_block = "\
  IDENTIFIER\000\
  CONSTANT\000\
  STRING_LITERAL\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Jc_ast.pdecl list) in
    Obj.repr(
# 161 "jc/jc_parser.mly"
    ( _1::_2 )
# 926 "jc/jc_parser.ml"
               : Jc_ast.pdecl list))
; (fun __caml_parser_env ->
    Obj.repr(
# 163 "jc/jc_parser.mly"
    ( [] )
# 932 "jc/jc_parser.ml"
               : Jc_ast.pdecl list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 168 "jc/jc_parser.mly"
    ( _1 )
# 939 "jc/jc_parser.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_definition) in
    Obj.repr(
# 170 "jc/jc_parser.mly"
    ( _1 )
# 946 "jc/jc_parser.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'axiom_definition) in
    Obj.repr(
# 172 "jc/jc_parser.mly"
    ( _1 )
# 953 "jc/jc_parser.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'exception_definition) in
    Obj.repr(
# 174 "jc/jc_parser.mly"
    ( _1 )
# 960 "jc/jc_parser.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'int_constant) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'int_constant) in
    Obj.repr(
# 188 "jc/jc_parser.mly"
    ( locate_decl (JCPDrangetype(_2,_4,_6)) )
# 969 "jc/jc_parser.ml"
               : 'type_definition))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 5 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'extends) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'field_declaration_list) in
    Obj.repr(
# 190 "jc/jc_parser.mly"
    ( let (f,i) = _6 in locate_decl (JCPDstructtype(_2,_4,f,i)) )
# 978 "jc/jc_parser.ml"
               : 'type_definition))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 192 "jc/jc_parser.mly"
    ( locate_decl (JCPDlogictype(_3)) )
# 985 "jc/jc_parser.ml"
               : 'type_definition))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Jc_ast.const) in
    Obj.repr(
# 197 "jc/jc_parser.mly"
    ( num_of_constant (loc_i 1)_1 )
# 992 "jc/jc_parser.ml"
               : 'int_constant))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Jc_ast.const) in
    Obj.repr(
# 199 "jc/jc_parser.mly"
    ( Num.minus_num (num_of_constant (loc_i 2) _2) )
# 999 "jc/jc_parser.ml"
               : 'int_constant))
; (fun __caml_parser_env ->
    Obj.repr(
# 204 "jc/jc_parser.mly"
    ( None )
# 1005 "jc/jc_parser.ml"
               : 'extends))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : string) in
    Obj.repr(
# 206 "jc/jc_parser.mly"
    ( Some _1 )
# 1012 "jc/jc_parser.ml"
               : 'extends))
; (fun __caml_parser_env ->
    Obj.repr(
# 211 "jc/jc_parser.mly"
    ( ([],[]) )
# 1018 "jc/jc_parser.ml"
               : 'field_declaration_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'field_declaration) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'field_declaration_list) in
    Obj.repr(
# 213 "jc/jc_parser.mly"
    ( let (f,i) = _2 in (_1::f,i) )
# 1026 "jc/jc_parser.ml"
               : 'field_declaration_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'invariant) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'field_declaration_list) in
    Obj.repr(
# 215 "jc/jc_parser.mly"
    ( let (f,i) = _2 in (f,_1::i) )
# 1034 "jc/jc_parser.ml"
               : 'field_declaration_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'type_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string) in
    Obj.repr(
# 220 "jc/jc_parser.mly"
    ( (_1,_2) )
# 1042 "jc/jc_parser.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 6 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 4 : string) in
    let _7 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 225 "jc/jc_parser.mly"
    ( (_2,_4,_7) )
# 1051 "jc/jc_parser.ml"
               : 'invariant))
; (fun __caml_parser_env ->
    Obj.repr(
# 237 "jc/jc_parser.mly"
    ( [] )
# 1057 "jc/jc_parser.ml"
               : 'parameters))
; (fun __caml_parser_env ->
    Obj.repr(
# 239 "jc/jc_parser.mly"
    ( [] )
# 1063 "jc/jc_parser.ml"
               : 'parameters))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_comma_list) in
    Obj.repr(
# 241 "jc/jc_parser.mly"
    ( _2 )
# 1070 "jc/jc_parser.ml"
               : 'parameters))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_declaration) in
    Obj.repr(
# 246 "jc/jc_parser.mly"
    ( [_1] )
# 1077 "jc/jc_parser.ml"
               : 'parameter_comma_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_declaration) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_comma_list) in
    Obj.repr(
# 248 "jc/jc_parser.mly"
    ( _1 :: _3 )
# 1085 "jc/jc_parser.ml"
               : 'parameter_comma_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 253 "jc/jc_parser.mly"
    ( (_1,_2) )
# 1093 "jc/jc_parser.ml"
               : 'parameter_declaration))
; (fun __caml_parser_env ->
    Obj.repr(
# 259 "jc/jc_parser.mly"
    ( locate_type (JCPTnative Tinteger) )
# 1099 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 261 "jc/jc_parser.mly"
    ( locate_type (JCPTnative Tboolean) )
# 1105 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 263 "jc/jc_parser.mly"
    ( locate_type (JCPTnative Treal) )
# 1111 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 265 "jc/jc_parser.mly"
    ( locate_type (JCPTnative Tunit) )
# 1117 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 267 "jc/jc_parser.mly"
    ( locate_type (JCPTidentifier _1) )
# 1124 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    Obj.repr(
# 269 "jc/jc_parser.mly"
    ( locate_type (JCPTpointer(_1,zero,minus_one)) )
# 1131 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Jc_ast.const) in
    Obj.repr(
# 271 "jc/jc_parser.mly"
    ( let n = num_of_constant (loc_i 3) _3 in
      locate_type (JCPTpointer(_1,n,n)) )
# 1140 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Jc_ast.const) in
    Obj.repr(
# 274 "jc/jc_parser.mly"
    ( let n = num_of_constant (loc_i 3) _3 in
      locate_type (JCPTpointer(_1,n,Num.pred_num n)) )
# 1149 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Jc_ast.const) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Jc_ast.const) in
    Obj.repr(
# 277 "jc/jc_parser.mly"
    ( let n = num_of_constant (loc_i 3) _3 in
      let m = num_of_constant (loc_i 5) _5 in
      locate_type (JCPTpointer(_1,n,m)) )
# 1160 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Jc_ast.const) in
    Obj.repr(
# 281 "jc/jc_parser.mly"
    ( let m = num_of_constant (loc_i 4) _4 in
      locate_type (JCPTpointer(_1,Num.succ_num m,m)) )
# 1169 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 287 "jc/jc_parser.mly"
    ( [] )
# 1175 "jc/jc_parser.ml"
               : 'function_specification))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'spec_clause) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'function_specification) in
    Obj.repr(
# 289 "jc/jc_parser.mly"
    ( _1::_2 )
# 1183 "jc/jc_parser.ml"
               : 'function_specification))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 294 "jc/jc_parser.mly"
    ( JCPCrequires(_2) )
# 1190 "jc/jc_parser.ml"
               : 'spec_clause))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 7 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 5 : 'throws) in
    let _5 = (Parsing.peek_val __caml_parser_env 4 : 'assumes) in
    let _6 = (Parsing.peek_val __caml_parser_env 3 : 'assigns) in
    let _8 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 296 "jc/jc_parser.mly"
    ( JCPCbehavior(_2,_4,_5,_6,_8) )
# 1201 "jc/jc_parser.ml"
               : 'spec_clause))
; (fun __caml_parser_env ->
    Obj.repr(
# 302 "jc/jc_parser.mly"
    ( None )
# 1207 "jc/jc_parser.ml"
               : 'throws))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'identifier) in
    Obj.repr(
# 304 "jc/jc_parser.mly"
    ( Some _2 )
# 1214 "jc/jc_parser.ml"
               : 'throws))
; (fun __caml_parser_env ->
    Obj.repr(
# 309 "jc/jc_parser.mly"
    ( None )
# 1220 "jc/jc_parser.ml"
               : 'assumes))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 311 "jc/jc_parser.mly"
    ( Some _2 )
# 1227 "jc/jc_parser.ml"
               : 'assumes))
; (fun __caml_parser_env ->
    Obj.repr(
# 316 "jc/jc_parser.mly"
    ( None )
# 1233 "jc/jc_parser.ml"
               : 'assigns))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'argument_expression_list) in
    Obj.repr(
# 318 "jc/jc_parser.mly"
    ( Some _2 )
# 1240 "jc/jc_parser.ml"
               : 'assigns))
; (fun __caml_parser_env ->
    Obj.repr(
# 320 "jc/jc_parser.mly"
    ( Some [] )
# 1246 "jc/jc_parser.ml"
               : 'assigns))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'type_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'parameters) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'function_specification) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'compound_statement) in
    Obj.repr(
# 326 "jc/jc_parser.mly"
    ( locate_decl (JCPDfun(_1, _2, _3, _4, _5)) )
# 1257 "jc/jc_parser.ml"
               : 'function_definition))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 335 "jc/jc_parser.mly"
    ( locate_decl( JCPDaxiom(_2,_4)) )
# 1265 "jc/jc_parser.ml"
               : 'axiom_definition))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'type_expr) in
    Obj.repr(
# 345 "jc/jc_parser.mly"
    ( locate_decl (JCPDexception(_2,_4)) )
# 1273 "jc/jc_parser.ml"
               : 'exception_definition))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 355 "jc/jc_parser.mly"
    ( locate_expr (JCPEvar _1) )
# 1280 "jc/jc_parser.ml"
               : 'primary_expression))
; (fun __caml_parser_env ->
    Obj.repr(
# 357 "jc/jc_parser.mly"
    ( locate_expr (JCPEvar "\\result") )
# 1286 "jc/jc_parser.ml"
               : 'primary_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Jc_ast.const) in
    Obj.repr(
# 359 "jc/jc_parser.mly"
    ( locate_expr (JCPEconst _1) )
# 1293 "jc/jc_parser.ml"
               : 'primary_expression))
; (fun __caml_parser_env ->
    Obj.repr(
# 361 "jc/jc_parser.mly"
    ( locate_expr (JCPEconst JCCvoid) )
# 1299 "jc/jc_parser.ml"
               : 'primary_expression))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 366 "jc/jc_parser.mly"
                       ( _2 )
# 1306 "jc/jc_parser.ml"
               : 'primary_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'primary_expression) in
    Obj.repr(
# 371 "jc/jc_parser.mly"
    ( _1 )
# 1313 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'primary_expression) in
    Obj.repr(
# 373 "jc/jc_parser.mly"
    ( locate_expr (JCPEapp(_1, [])) )
# 1320 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'primary_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_expression_list) in
    Obj.repr(
# 375 "jc/jc_parser.mly"
    ( locate_expr (JCPEapp(_1, _3)) )
# 1328 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 377 "jc/jc_parser.mly"
    ( locate_expr (JCPEold(_3)) )
# 1335 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 379 "jc/jc_parser.mly"
    ( locate_expr (JCPEoffset_max(_3)) )
# 1342 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 381 "jc/jc_parser.mly"
    ( locate_expr (JCPEoffset_min(_3)) )
# 1349 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 383 "jc/jc_parser.mly"
    ( locate_expr (JCPEderef (_1, _3)) )
# 1357 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expression) in
    Obj.repr(
# 385 "jc/jc_parser.mly"
    ( locate_expr (JCPEunary (Upostfix_inc, _1)) )
# 1364 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expression) in
    Obj.repr(
# 387 "jc/jc_parser.mly"
    ( locate_expr (JCPEunary (Upostfix_dec, _1)) )
# 1371 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 389 "jc/jc_parser.mly"
    ( locate_expr (JCPEunary (Uprefix_inc, _2)) )
# 1378 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 391 "jc/jc_parser.mly"
    ( locate_expr (JCPEunary (Uprefix_dec, _2)) )
# 1385 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 393 "jc/jc_parser.mly"
    ( locate_expr (JCPEunary (Uplus, _2)) )
# 1392 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 395 "jc/jc_parser.mly"
    ( locate_expr (JCPEunary (Uminus, _2)) )
# 1399 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 401 "jc/jc_parser.mly"
    ( locate_expr (JCPEunary (Unot, _2)) )
# 1406 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assignment_expression) in
    Obj.repr(
# 406 "jc/jc_parser.mly"
    ( [_1] )
# 1413 "jc/jc_parser.ml"
               : 'argument_expression_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'assignment_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument_expression_list) in
    Obj.repr(
# 408 "jc/jc_parser.mly"
    ( _1::_3 )
# 1421 "jc/jc_parser.ml"
               : 'argument_expression_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 414 "jc/jc_parser.mly"
    ( _1 )
# 1428 "jc/jc_parser.ml"
               : 'multiplicative_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'multiplicative_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 416 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Bmul, _3)) )
# 1436 "jc/jc_parser.ml"
               : 'multiplicative_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'multiplicative_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 418 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Bdiv, _3)) )
# 1444 "jc/jc_parser.ml"
               : 'multiplicative_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'multiplicative_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 420 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Bmod, _3)) )
# 1452 "jc/jc_parser.ml"
               : 'multiplicative_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'multiplicative_expression) in
    Obj.repr(
# 425 "jc/jc_parser.mly"
    ( _1 )
# 1459 "jc/jc_parser.ml"
               : 'additive_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'additive_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'multiplicative_expression) in
    Obj.repr(
# 427 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Badd, _3)) )
# 1467 "jc/jc_parser.ml"
               : 'additive_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'additive_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'multiplicative_expression) in
    Obj.repr(
# 429 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Bsub, _3)) )
# 1475 "jc/jc_parser.ml"
               : 'additive_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'additive_expression) in
    Obj.repr(
# 434 "jc/jc_parser.mly"
    ( _1 )
# 1482 "jc/jc_parser.ml"
               : 'shift_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'shift_expression) in
    Obj.repr(
# 445 "jc/jc_parser.mly"
    ( _1 )
# 1489 "jc/jc_parser.ml"
               : 'relational_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'relational_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'shift_expression) in
    Obj.repr(
# 447 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Blt, _3)) )
# 1497 "jc/jc_parser.ml"
               : 'relational_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'relational_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'shift_expression) in
    Obj.repr(
# 449 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Bgt, _3)) )
# 1505 "jc/jc_parser.ml"
               : 'relational_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'relational_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'shift_expression) in
    Obj.repr(
# 451 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Ble, _3)) )
# 1513 "jc/jc_parser.ml"
               : 'relational_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'relational_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'shift_expression) in
    Obj.repr(
# 453 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Bge, _3)) )
# 1521 "jc/jc_parser.ml"
               : 'relational_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'relational_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 455 "jc/jc_parser.mly"
    ( locate_expr (JCPEinstanceof(_1, _3)) )
# 1529 "jc/jc_parser.ml"
               : 'relational_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'relational_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 457 "jc/jc_parser.mly"
    ( locate_expr (JCPEcast(_1, _3)) )
# 1537 "jc/jc_parser.ml"
               : 'relational_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'relational_expression) in
    Obj.repr(
# 462 "jc/jc_parser.mly"
    ( _1 )
# 1544 "jc/jc_parser.ml"
               : 'equality_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'equality_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'relational_expression) in
    Obj.repr(
# 464 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Beq, _3)) )
# 1552 "jc/jc_parser.ml"
               : 'equality_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'equality_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'relational_expression) in
    Obj.repr(
# 466 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Bneq, _3)) )
# 1560 "jc/jc_parser.ml"
               : 'equality_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'equality_expression) in
    Obj.repr(
# 471 "jc/jc_parser.mly"
    ( _1 )
# 1567 "jc/jc_parser.ml"
               : 'and_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'and_expression) in
    Obj.repr(
# 480 "jc/jc_parser.mly"
    ( _1 )
# 1574 "jc/jc_parser.ml"
               : 'exclusive_or_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'exclusive_or_expression) in
    Obj.repr(
# 489 "jc/jc_parser.mly"
    ( _1 )
# 1581 "jc/jc_parser.ml"
               : 'inclusive_or_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'inclusive_or_expression) in
    Obj.repr(
# 498 "jc/jc_parser.mly"
    ( _1 )
# 1588 "jc/jc_parser.ml"
               : 'logical_and_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'logical_and_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'inclusive_or_expression) in
    Obj.repr(
# 500 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary(_1, Bland, _3)) )
# 1596 "jc/jc_parser.ml"
               : 'logical_and_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'logical_and_expression) in
    Obj.repr(
# 505 "jc/jc_parser.mly"
    ( _1 )
# 1603 "jc/jc_parser.ml"
               : 'logical_or_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'logical_or_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'logical_and_expression) in
    Obj.repr(
# 507 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary(_1, Blor, _3)) )
# 1611 "jc/jc_parser.ml"
               : 'logical_or_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'logical_or_expression) in
    Obj.repr(
# 512 "jc/jc_parser.mly"
    ( _1 )
# 1618 "jc/jc_parser.ml"
               : 'conditional_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'logical_or_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'conditional_expression) in
    Obj.repr(
# 514 "jc/jc_parser.mly"
    ( locate_expr (JCPEif (_1, _3, _5)) )
# 1627 "jc/jc_parser.ml"
               : 'conditional_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'conditional_expression) in
    Obj.repr(
# 520 "jc/jc_parser.mly"
    ( _1 )
# 1634 "jc/jc_parser.ml"
               : 'assignment_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'assignment_operator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assignment_expression) in
    Obj.repr(
# 522 "jc/jc_parser.mly"
    ( let a  =
	match _2 with
		| `Aeq -> JCPEassign (_1, _3)
		| `Aadd -> JCPEassign_op (_1, Badd, _3)
		| `Asub -> JCPEassign_op (_1, Bsub, _3)
		| `Amul -> JCPEassign_op (_1, Bmul, _3)
		| `Adiv -> JCPEassign_op (_1, Bdiv, _3)
		| `Amod -> JCPEassign_op (_1, Bmod, _3)
(*
		| Aleft -> CEassign_op ($1, Bshift_left, $3)
		| Aright -> CEassign_op ($1, Bshift_right, $3)
		| Aand -> CEassign_op ($1, Bbw_and, $3)
		| Axor -> CEassign_op ($1, Bbw_xor, $3)
		| Aor -> CEassign_op ($1, Bbw_or, $3)
*)
      in locate_expr a )
# 1658 "jc/jc_parser.ml"
               : 'assignment_expression))
; (fun __caml_parser_env ->
    Obj.repr(
# 541 "jc/jc_parser.mly"
     ( `Aeq )
# 1664 "jc/jc_parser.ml"
               : 'assignment_operator))
; (fun __caml_parser_env ->
    Obj.repr(
# 542 "jc/jc_parser.mly"
         ( `Aadd )
# 1670 "jc/jc_parser.ml"
               : 'assignment_operator))
; (fun __caml_parser_env ->
    Obj.repr(
# 543 "jc/jc_parser.mly"
          ( `Asub )
# 1676 "jc/jc_parser.ml"
               : 'assignment_operator))
; (fun __caml_parser_env ->
    Obj.repr(
# 544 "jc/jc_parser.mly"
         ( `Amul )
# 1682 "jc/jc_parser.ml"
               : 'assignment_operator))
; (fun __caml_parser_env ->
    Obj.repr(
# 545 "jc/jc_parser.mly"
          ( `Adiv )
# 1688 "jc/jc_parser.ml"
               : 'assignment_operator))
; (fun __caml_parser_env ->
    Obj.repr(
# 546 "jc/jc_parser.mly"
            ( `Amod )
# 1694 "jc/jc_parser.ml"
               : 'assignment_operator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assignment_expression) in
    Obj.repr(
# 559 "jc/jc_parser.mly"
    ( _1 )
# 1701 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'type_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 562 "jc/jc_parser.mly"
    ( locate_expr (JCPEforall(_2,_3,_5)) )
# 1710 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 564 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary(_1,Bimplies,_3)) )
# 1718 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 566 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary(_1,Biff,_3)) )
# 1726 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 574 "jc/jc_parser.mly"
    ( [_1] )
# 1733 "jc/jc_parser.ml"
               : 'identifier_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_list) in
    Obj.repr(
# 576 "jc/jc_parser.mly"
    ( _1 :: _3 )
# 1741 "jc/jc_parser.ml"
               : 'identifier_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 581 "jc/jc_parser.mly"
    ( { jc_identifier_loc = loc () ; jc_identifier_name = _1 } )
# 1748 "jc/jc_parser.ml"
               : 'identifier))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'type_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string) in
    Obj.repr(
# 591 "jc/jc_parser.mly"
    ( locate_statement (JCPSdecl(_1,_2,None)) )
# 1756 "jc/jc_parser.ml"
               : 'declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'type_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 593 "jc/jc_parser.mly"
    ( locate_statement (JCPSdecl(_1,_2,Some _4)) )
# 1765 "jc/jc_parser.ml"
               : 'declaration))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'statement_list) in
    Obj.repr(
# 612 "jc/jc_parser.mly"
     ( _2 )
# 1772 "jc/jc_parser.ml"
               : 'compound_statement))
; (fun __caml_parser_env ->
    Obj.repr(
# 617 "jc/jc_parser.mly"
    ( [] )
# 1778 "jc/jc_parser.ml"
               : 'statement_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'statement) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'statement_list) in
    Obj.repr(
# 619 "jc/jc_parser.mly"
    ( _1 :: _2 )
# 1786 "jc/jc_parser.ml"
               : 'statement_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 625 "jc/jc_parser.mly"
    ( skip )
# 1792 "jc/jc_parser.ml"
               : 'expression_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 630 "jc/jc_parser.mly"
    ( locate_statement (JCPSexpr _1) )
# 1799 "jc/jc_parser.ml"
               : 'expression_statement))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'statement) in
    Obj.repr(
# 636 "jc/jc_parser.mly"
    ( locate_statement (JCPSif(_3, _5, skip)) )
# 1807 "jc/jc_parser.ml"
               : 'selection_statement))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : 'statement) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : 'statement) in
    Obj.repr(
# 638 "jc/jc_parser.mly"
    ( locate_statement (JCPSif (_3, _5, _7)) )
# 1816 "jc/jc_parser.ml"
               : 'selection_statement))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'loop_annot) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'statement) in
    Obj.repr(
# 647 "jc/jc_parser.mly"
    ( let (i,v) = _3 in 
      locate_statement (JCPSwhile (_2, i, v, _4)) )
# 1826 "jc/jc_parser.ml"
               : 'iteration_statement))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 667 "jc/jc_parser.mly"
    ( (_2,_5) )
# 1834 "jc/jc_parser.ml"
               : 'loop_annot))
; (fun __caml_parser_env ->
    Obj.repr(
# 675 "jc/jc_parser.mly"
                  ( locate_statement (JCPSbreak "") )
# 1840 "jc/jc_parser.ml"
               : 'jump_statement))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 679 "jc/jc_parser.mly"
                              ( locate_statement (JCPSreturn _2) )
# 1847 "jc/jc_parser.ml"
               : 'jump_statement))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    Obj.repr(
# 684 "jc/jc_parser.mly"
    ( locate_statement (JCPSpack _3 ) )
# 1854 "jc/jc_parser.ml"
               : 'pack_statement))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    Obj.repr(
# 686 "jc/jc_parser.mly"
    ( locate_statement (JCPSunpack _3 ) )
# 1861 "jc/jc_parser.ml"
               : 'pack_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'compound_statement) in
    Obj.repr(
# 695 "jc/jc_parser.mly"
    ( locate_statement (JCPSblock _1) )
# 1868 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'expression_statement) in
    Obj.repr(
# 697 "jc/jc_parser.mly"
    ( _1 )
# 1875 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'selection_statement) in
    Obj.repr(
# 699 "jc/jc_parser.mly"
    ( _1 )
# 1882 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'iteration_statement) in
    Obj.repr(
# 701 "jc/jc_parser.mly"
    ( _1 )
# 1889 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'jump_statement) in
    Obj.repr(
# 703 "jc/jc_parser.mly"
    ( _1 )
# 1896 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaration) in
    Obj.repr(
# 705 "jc/jc_parser.mly"
    ( _1 )
# 1903 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'pack_statement) in
    Obj.repr(
# 709 "jc/jc_parser.mly"
                 ( _1 )
# 1910 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'exception_statement) in
    Obj.repr(
# 710 "jc/jc_parser.mly"
                      ( _1 )
# 1917 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 716 "jc/jc_parser.mly"
   ( locate_statement (JCPSthrow(_2,_3)) )
# 1925 "jc/jc_parser.ml"
               : 'exception_statement))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'identifier) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : string) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'statement) in
    Obj.repr(
# 718 "jc/jc_parser.mly"
   ( locate_statement (JCPStry(_2,[(_4,_5,_6)],skip)) )
# 1935 "jc/jc_parser.ml"
               : 'exception_statement))
(* Entry file *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let file (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : Jc_ast.pdecl list)
